; FGL - A Symbolic Simulation Framework for ACL2
; Copyright (C) 2019 Centaur Technology
;
; Contact:
;   Centaur Technology Formal Verification Group
;   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
;   http://www.centtech.com/
;
; License: (An MIT/X11-style license)
;
;   Permission is hereby granted, free of charge, to any person obtaining a
;   copy of this software and associated documentation files (the "Software"),
;   to deal in the Software without restriction, including without limitation
;   the rights to use, copy, modify, merge, publish, distribute, sublicense,
;   and/or sell copies of the Software, and to permit persons to whom the
;   Software is furnished to do so, subject to the following conditions:
;
;   The above copyright notice and this permission notice shall be included in
;   all copies or substantial portions of the Software.
;
;   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;   DEALINGS IN THE SOFTWARE.
;
; Original author: Sol Swords <sswords@centtech.com>

(in-package "FGL")

(include-book "top-bare")
(include-book "bitops-primitives")
(include-book "check-primitives")
(include-book "svex")
(include-book "member-equal")
(include-book "enums")
(include-book "transform")
(include-book "simplify")
(include-book "gatecount")
(include-book "sat-binder")
(include-book "equivcheck")
(include-book "extremize")

(local (in-theory (disable w)))

(install-fgl-metafns top)
(def-fancy-ev-primitives top-fancy-ev-primitives)

#||
(include-book
 "xdoc/save" :dir :system)
(include-book
 "std/util/defval-tests" :dir :system)
(include-book
 "centaur/fty/top" :dir :system)
(xdoc::change-parents fgl (acl2::top))
(xdoc::save "./manual"
            :redef-okp t
            :error t) 


||#
