
(IN-PACKAGE "ACL2")

(INCLUDE-BOOK "spec")

(DEFUN SGNX* NIL (SGNX (X*)))

(DEFUN SGNY* NIL (SGNY (Y*)))

(DEFUN EXPX* NIL (EXPX (X*)))

(DEFUN EXPY* NIL (EXPY (Y*)))

(DEFUN SGNZ* NIL (SGNZ (SGNX*) (SGNY*)))

(DEFUN RC_C2* NIL (RC_C2 (RC*)))

(DEFUN RCONST_SING_OF* NIL (RCONST_SING_OF (SGNZ*) (RC_C2*)))

(DEFUN RCONST_DOUB_OF* NIL (RCONST_DOUB_OF (SGNZ*) (RC_C2*)))

(DEFUN SIGX* NIL (SIGX (X*)))

(DEFUN SIGX_C3* NIL (SIGX_C3 (SIGX*)))

(DEFUN SIGY* NIL (SIGY (Y*)))

(DEFUN SIGY_C3* NIL (SIGY_C3 (SIGY*)))

(DEFUN PROD* NIL (PROD (SIGX_C3*) (SIGY_C3*)))

(DEFUN PC_C2* NIL (PC_C2 (PC*)))

(DEFUN RCONST_OF* NIL
       (RCONST_OF (RCONST_SING_OF*)
                  (PC_C2*)
                  (RCONST_DOUB_OF*)))


(DEFUN RCONST_NOF* NIL (RCONST_NOF (RCONST_OF*)))

(DEFUN PC_C3* NIL (PC_C3 (PC_C2*)))

(DEFUN PC_C4* NIL (PC_C4 (PC_C3*)))

(DEFUN RC_C3* NIL (RC_C3 (RC_C2*)))

(DEFUN RC_C4* NIL (RC_C4 (RC_C3*)))

(DEFUN STICKY_OF* NIL (STICKY_OF (PC_C3*) (PROD*)))

(DEFUN ADD_OF* NIL (ADD_OF (PROD*) (RCONST_OF*)))

(DEFUN MASK_OF* NIL (MASK_OF (PC_C4*) (RC_C4*) (STICKY_OF*) (ADD_OF*)))

(DEFUN STICKY_NOF* NIL (STICKY_NOF (PC_C3*) (PROD*)))

(DEFUN ADD_NOF* NIL (ADD_NOF (PROD*) (RCONST_NOF*)))

(DEFUN MASK_NOF* NIL (MASK_NOF (PC_C4*) (RC_C4*) (STICKY_NOF*) (ADD_NOF*)))

(DEFUN CARRY_OF* NIL (CARRY_OF (ADD_OF*)))

(DEFUN CARRY_NOF* NIL (CARRY_NOF (ADD_NOF*)))

(DEFUN SIG_OF* NIL (SIG_OF (CARRY_OF*) (ADD_OF*) (MASK_OF*)))

(DEFUN SIG_NOF* NIL (SIG_NOF (CARRY_NOF*) (ADD_NOF*) (MASK_NOF*)))

(DEFUN OVERFLOW* NIL (OVERFLOW (PROD*)))

(DEFUN SIGZ* NIL (SIGZ (OVERFLOW*) (SIG_NOF*) (SIG_OF*)))

(DEFUN EXP_SUM* NIL (EXP_SUM (EXPX*) (EXPY*)))

(DEFUN EXP_SUM_C3* NIL (EXP_SUM_C3 (EXP_SUM*)))

(DEFUN EXP_SUM_C4* NIL (EXP_SUM_C4 (EXP_SUM_C3*)))

(DEFUN EXP_OF* NIL (EXP_OF (EXP_SUM_C4*) (CARRY_OF*)))

(DEFUN EXP_NOF* NIL (EXP_NOF (EXP_SUM_C4*) (CARRY_NOF*)))

(DEFUN EXPZ* NIL (EXPZ (OVERFLOW*) (EXP_NOF*) (EXP_OF*)))

(DEFUN SGNZ_C3* NIL (SGNZ_C3 (SGNZ*)))

(DEFUN SGNZ_C4* NIL (SGNZ_C4 (SGNZ_C3*)))

(DEFUN Z* NIL (Z (SGNZ_C4*) (EXPZ*) (SIGZ*)))

(IN-THEORY (DISABLE SGNX SGNY EXPX EXPY
                    SGNZ RC_C2 RCONST_SING_OF RCONST_DOUB_OF
                    SIGX SIGX_C3 SIGY SIGY_C3 PROD
                    PC_C2 RCONST_OF RCONST_NOF PC_C3 PC_C4
                    RC_C3 RC_C4 STICKY_OF ADD_OF MASK_OF
                    STICKY_NOF ADD_NOF MASK_NOF CARRY_OF
                    CARRY_NOF SIG_OF SIG_NOF OVERFLOW
                    SIGZ EXP_SUM EXP_SUM_C3 EXP_SUM_C4
                    EXP_OF EXP_NOF EXPZ SGNZ_C3 SGNZ_C4 Z))


(IN-THEORY (DISABLE (:EXECUTABLE-COUNTERPART SGNX*)
                    (:EXECUTABLE-COUNTERPART SGNY*)
                    (:EXECUTABLE-COUNTERPART EXPX*)
                    (:EXECUTABLE-COUNTERPART EXPY*)
                    (:EXECUTABLE-COUNTERPART SGNZ*)
                    (:EXECUTABLE-COUNTERPART RC_C2*)
                    (:EXECUTABLE-COUNTERPART RCONST_SING_OF*)
                    (:EXECUTABLE-COUNTERPART RCONST_DOUB_OF*)
                    (:EXECUTABLE-COUNTERPART SIGX*)
                    (:EXECUTABLE-COUNTERPART SIGX_C3*)
                    (:EXECUTABLE-COUNTERPART SIGY*)
                    (:EXECUTABLE-COUNTERPART SIGY_C3*)
                    (:EXECUTABLE-COUNTERPART PROD*)
                    (:EXECUTABLE-COUNTERPART PC_C2*)
                    (:EXECUTABLE-COUNTERPART RCONST_OF*)
                    (:EXECUTABLE-COUNTERPART RCONST_NOF*)
                    (:EXECUTABLE-COUNTERPART PC_C3*)
                    (:EXECUTABLE-COUNTERPART PC_C4*)
                    (:EXECUTABLE-COUNTERPART RC_C3*)
                    (:EXECUTABLE-COUNTERPART RC_C4*)
                    (:EXECUTABLE-COUNTERPART STICKY_OF*)
                    (:EXECUTABLE-COUNTERPART ADD_OF*)
                    (:EXECUTABLE-COUNTERPART MASK_OF*)
                    (:EXECUTABLE-COUNTERPART STICKY_NOF*)
                    (:EXECUTABLE-COUNTERPART ADD_NOF*)
                    (:EXECUTABLE-COUNTERPART MASK_NOF*)
                    (:EXECUTABLE-COUNTERPART CARRY_OF*)
                    (:EXECUTABLE-COUNTERPART CARRY_NOF*)
                    (:EXECUTABLE-COUNTERPART SIG_OF*)
                    (:EXECUTABLE-COUNTERPART SIG_NOF*)
                    (:EXECUTABLE-COUNTERPART OVERFLOW*)
                    (:EXECUTABLE-COUNTERPART SIGZ*)
                    (:EXECUTABLE-COUNTERPART EXP_SUM*)
                    (:EXECUTABLE-COUNTERPART EXP_SUM_C3*)
                    (:EXECUTABLE-COUNTERPART EXP_SUM_C4*)
                    (:EXECUTABLE-COUNTERPART EXP_OF*)
                    (:EXECUTABLE-COUNTERPART EXP_NOF*)
                    (:EXECUTABLE-COUNTERPART EXPZ*)
                    (:EXECUTABLE-COUNTERPART SGNZ_C3*)
                    (:EXECUTABLE-COUNTERPART SGNZ_C4*)
                    (:EXECUTABLE-COUNTERPART Z*)))


(DEFTHM FMUL-STAR-EQUIVALENCE
        (EQUAL (Z*)
               (FMUL (X*) (Y*) (RC*) (PC*)))
        :RULE-CLASSES NIL)


(IN-THEORY (DISABLE SGNX* SGNY*
                    EXPX* EXPY* SGNZ* RC_C2* RCONST_SING_OF*
                    RCONST_DOUB_OF* SIGX* SIGX_C3*
                    SIGY* SIGY_C3* PROD* PC_C2* RCONST_OF*
                    RCONST_NOF* PC_C3* PC_C4* RC_C3* RC_C4*
                    STICKY_OF* ADD_OF* MASK_OF* STICKY_NOF*
                    ADD_NOF* MASK_NOF* CARRY_OF* CARRY_NOF*
                    SIG_OF* SIG_NOF* OVERFLOW* SIGZ*
                    EXP_SUM* EXP_SUM_C3* EXP_SUM_C4* EXP_OF*
                    EXP_NOF* EXPZ* SGNZ_C3* SGNZ_C4* Z*))


(IN-THEORY (ENABLE SGNX SGNY EXPX EXPY
                   SGNZ RC_C2 RCONST_SING_OF RCONST_DOUB_OF
                   SIGX SIGX_C3 SIGY SIGY_C3 PROD
                   PC_C2 RCONST_OF RCONST_NOF PC_C3 PC_C4
                   RC_C3 RC_C4 STICKY_OF ADD_OF MASK_OF
                   STICKY_NOF ADD_NOF MASK_NOF CARRY_OF
                   CARRY_NOF SIG_OF SIG_NOF OVERFLOW
                   SIGZ EXP_SUM EXP_SUM_C3 EXP_SUM_C4
                   EXP_OF EXP_NOF EXPZ SGNZ_C3 SGNZ_C4 Z))

