
(IN-PACKAGE "ACL2")

(INCLUDE-BOOK "rtl")

(DEFUN SGNX (X) (BITN X 79))

(DEFUN SGNY (Y) (BITN Y 79))

(DEFUN EXPX (X) (BITS X 78 64))

(DEFUN EXPY (Y) (BITS Y 78 64))

(DEFUN SGNZ (SGNX SGNY) (LOGXOR SGNX SGNY))

(DEFUN RC_C2 (RC) RC)

(DEFUN RCONST_SING_OF (SGNZ RC_C2)
       (COND ((EQUAL RC_C2 0) (CAT 1 0 103))
             ((EQUAL RC_C2 1)
              (IF (EQUAL SGNZ 0) 0 (MULCAT 104 1 1)))
             ((EQUAL RC_C2 2)
              (IF (EQUAL SGNZ 0) (MULCAT 104 1 1) 0))
             ((EQUAL RC_C2 3) 0)))


(DEFUN RCONST_DOUB_OF (SGNZ RC_C2)
       (COND ((EQUAL RC_C2 0) (CAT 1 0 74))
             ((EQUAL RC_C2 1)
              (IF (EQUAL SGNZ 0) 0 (MULCAT 75 1 1)))
             ((EQUAL RC_C2 2)
              (IF (EQUAL SGNZ 0) (MULCAT 75 1 1) 0))
             ((EQUAL RC_C2 3) 0)))


(DEFUN SIGX (X) (BITS X 63 0))

(DEFUN SIGX_C3 (SIGX) SIGX)

(DEFUN SIGY (Y) (BITS Y 63 0))

(DEFUN SIGY_C3 (SIGY) SIGY)

(DEFUN PROD (SIGX_C3 SIGY_C3) (BITS (* SIGX_C3 SIGY_C3) 127 0))

(DEFUN PC_C2 (PC) PC)

(DEFUN RCONST_OF
       (RCONST_SING_OF PC_C2 RCONST_DOUB_OF)
       (COND ((EQUAL PC_C2 0) RCONST_SING_OF)
             ((EQUAL PC_C2 1) RCONST_DOUB_OF)))


(DEFUN RCONST_NOF (RCONST_OF) (BITS RCONST_OF 127 1))

(DEFUN PC_C3 (PC_C2) PC_C2)

(DEFUN PC_C4 (PC_C3) PC_C3)

(DEFUN RC_C3 (RC_C2) RC_C2)

(DEFUN RC_C4 (RC_C3) RC_C3)

(DEFUN STICKY_OF (PC_C3 PROD)
       (COND ((EQUAL PC_C3 0)
              (IF (EQUAL (BITS PROD 102 0) 0) 0 1))
             ((EQUAL PC_C3 1)
              (IF (EQUAL (BITS PROD 73 0) 0) 0 1))))


(DEFUN ADD_OF (PROD RCONST_OF) (BITS (+ PROD RCONST_OF) 128 0))

(DEFUN MASK_OF (PC_C4 RC_C4 STICKY_OF ADD_OF)
       (COND ((EQUAL PC_C4 0)
              (IF (EQUAL (LOGAND (LOGAND (LOG= RC_C4 0)
                                         (COMP1 STICKY_OF 1))
                                 (COMP1 (BITN ADD_OF 103) 1))
                         0)
                  (CAT (MULCAT 24 1 1) 0 104)
                  (CAT (MULCAT 23 1 1) 0 105)))
             ((EQUAL PC_C4 1)
              (IF (EQUAL (LOGAND (LOGAND (LOG= RC_C4 0)
                                         (COMP1 STICKY_OF 1))
                                 (COMP1 (BITN ADD_OF 74) 1))
                         0)
                  (CAT (MULCAT 53 1 1) 0 75)
                  (CAT (MULCAT 52 1 1) 0 76)))))


(DEFUN STICKY_NOF (PC_C3 PROD)
       (COND ((EQUAL PC_C3 0)
              (IF (EQUAL (BITS PROD 101 0) 0) 0 1))
             ((EQUAL PC_C3 1)
              (IF (EQUAL (BITS PROD 72 0) 0) 0 1))))


(DEFUN ADD_NOF (PROD RCONST_NOF) (BITS (+ PROD RCONST_NOF) 127 0))

(DEFUN MASK_NOF
       (PC_C4 RC_C4 STICKY_NOF ADD_NOF)
       (COND ((EQUAL PC_C4 0)
              (IF (EQUAL (LOGAND (LOGAND (LOG= RC_C4 0)
                                         (COMP1 STICKY_NOF 1))
                                 (COMP1 (BITN ADD_NOF 102) 1))
                         0)
                  (CAT (MULCAT 24 1 1) 0 103)
                  (CAT (MULCAT 23 1 1) 0 104)))
             ((EQUAL PC_C4 1)
              (IF (EQUAL (LOGAND (LOGAND (LOG= RC_C4 0)
                                         (COMP1 STICKY_NOF 1))
                                 (COMP1 (BITN ADD_NOF 73) 1))
                         0)
                  (CAT (MULCAT 53 1 1) 0 74)
                  (CAT (MULCAT 52 1 1) 0 75)))))


(DEFUN CARRY_OF (ADD_OF) (BITN ADD_OF 128))

(DEFUN CARRY_NOF (ADD_NOF) (BITN ADD_NOF 127))

(DEFUN SIG_OF (CARRY_OF ADD_OF MASK_OF)
       (LOGIOR (CAT CARRY_OF 0 127)
               (LOGAND ADD_OF MASK_OF)))


(DEFUN SIG_NOF (CARRY_NOF ADD_NOF MASK_NOF)
       (LOGIOR (CAT CARRY_NOF 0 126)
               (LOGAND ADD_NOF MASK_NOF)))


(DEFUN OVERFLOW (PROD) (BITN PROD 127))

(DEFUN SIGZ (OVERFLOW SIG_NOF SIG_OF)
       (IF (EQUAL OVERFLOW 0)
           (BITS SIG_NOF 126 63)
           (BITS SIG_OF 127 64)))


(DEFUN EXP_SUM (EXPX EXPY) (BITS (+ (BITS (+ EXPX EXPY) 14 0) 16385) 14 0))

(DEFUN EXP_SUM_C3 (EXP_SUM) EXP_SUM)

(DEFUN EXP_SUM_C4 (EXP_SUM_C3) EXP_SUM_C3)

(DEFUN EXP_OF (EXP_SUM_C4 CARRY_OF)
       (BITS (+ (BITS (+ EXP_SUM_C4 CARRY_OF) 14 0)
                1)
             14 0))


(DEFUN EXP_NOF (EXP_SUM_C4 CARRY_NOF) (BITS (+ EXP_SUM_C4 CARRY_NOF) 14 0))

(DEFUN EXPZ (OVERFLOW EXP_NOF EXP_OF) (IF (EQUAL OVERFLOW 0) EXP_NOF EXP_OF))

(DEFUN SGNZ_C3 (SGNZ) SGNZ)

(DEFUN SGNZ_C4 (SGNZ_C3) SGNZ_C3)

(DEFUN Z (SGNZ_C4 EXPZ SIGZ) (CAT (CAT SGNZ_C4 EXPZ 15) SIGZ 64))

(SET-IGNORE-OK T)

(DEFUN FMUL (X Y RC PC)
       (LET* ((SGNX (SGNX X))
              (SGNY (SGNY Y))
              (EXPX (EXPX X))
              (EXPY (EXPY Y))
              (SGNZ (SGNZ SGNX SGNY))
              (RC_C2 (RC_C2 RC))
              (RCONST_SING_OF (RCONST_SING_OF SGNZ RC_C2))
              (RCONST_DOUB_OF (RCONST_DOUB_OF SGNZ RC_C2))
              (SIGX (SIGX X))
              (SIGX_C3 (SIGX_C3 SIGX))
              (SIGY (SIGY Y))
              (SIGY_C3 (SIGY_C3 SIGY))
              (PROD (PROD SIGX_C3 SIGY_C3))
              (PC_C2 (PC_C2 PC))
              (RCONST_OF (RCONST_OF RCONST_SING_OF PC_C2 RCONST_DOUB_OF))
              (RCONST_NOF (RCONST_NOF RCONST_OF))
              (PC_C3 (PC_C3 PC_C2))
              (PC_C4 (PC_C4 PC_C3))
              (RC_C3 (RC_C3 RC_C2))
              (RC_C4 (RC_C4 RC_C3))
              (STICKY_OF (STICKY_OF PC_C3 PROD))
              (ADD_OF (ADD_OF PROD RCONST_OF))
              (MASK_OF (MASK_OF PC_C4 RC_C4 STICKY_OF ADD_OF))
              (STICKY_NOF (STICKY_NOF PC_C3 PROD))
              (ADD_NOF (ADD_NOF PROD RCONST_NOF))
              (MASK_NOF (MASK_NOF PC_C4 RC_C4 STICKY_NOF ADD_NOF))
              (CARRY_OF (CARRY_OF ADD_OF))
              (CARRY_NOF (CARRY_NOF ADD_NOF))
              (SIG_OF (SIG_OF CARRY_OF ADD_OF MASK_OF))
              (SIG_NOF (SIG_NOF CARRY_NOF ADD_NOF MASK_NOF))
              (OVERFLOW (OVERFLOW PROD))
              (SIGZ (SIGZ OVERFLOW SIG_NOF SIG_OF))
              (EXP_SUM (EXP_SUM EXPX EXPY))
              (EXP_SUM_C3 (EXP_SUM_C3 EXP_SUM))
              (EXP_SUM_C4 (EXP_SUM_C4 EXP_SUM_C3))
              (EXP_OF (EXP_OF EXP_SUM_C4 CARRY_OF))
              (EXP_NOF (EXP_NOF EXP_SUM_C4 CARRY_NOF))
              (EXPZ (EXPZ OVERFLOW EXP_NOF EXP_OF))
              (SGNZ_C3 (SGNZ_C3 SGNZ))
              (SGNZ_C4 (SGNZ_C4 SGNZ_C3))
              (Z (Z SGNZ_C4 EXPZ SIGZ)))
             Z))

